// $Id: ContThread.cc,v 1.5.2.1 1998/09/22 07:43:25 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "ContThread.h"
#include "Log.h"


SafePtrDefn(ContThreadPtr, ContThread)

/* ContRec */

void ContRec::req(const HttpReqHdrPtr &aReqHdr) {
	theReqHdr.assign(aReqHdr, aReqHdr);
}

void ContRec::rep(const HttpRepHdrPtr &aRepHdr) {
	theRepHdr.assign(aRepHdr, aRepHdr);
}
 

/* ContThread */

void ContThread::run() {
	const IOBuffer &buf = workBuf();
	const IOBuffer::State bufState = buf.state();

	doContent();

	Notepad << this << " progress:" << sizeMade() << '/' << sizeTotal() << " buf: " << buf.contSize() << ende;
	if (buf.state() != bufState) {
		sendBufChange();
		checkProgress();
	} else {
		Notepad << this << " progress: none" << ende;
	}
}

void ContThread::sendContChange() {
	thCall(theContPartner, otherContChanged, theCont);
}
