// $Id: TopProcess.cc,v 1.9.2.1 1998/09/22 07:43:45 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "TopProcess.h"
#include "StatShooters.h"

#include <iostream.h>
#include <iomanip.h>

void TopProcess::taskStarted(Thread *th) {
	extern RateMeter TheSubmMeter;
	extern EventCounter stSubmCount;
	extern LevelMeter stCcLevel;

	Process::taskStarted(th);
	TheSubmMeter.tick();
	theSubm.tick();
	stSubmCount++;
	stCcLevel++;
}

void TopProcess::taskStopped(Thread *th) {
	extern RateMeter TheComplMeter;
	extern EventCounter stComplCount;
	extern LevelMeter stCcLevel;

	Process::taskStopped(th);
	TheComplMeter.tick();
	theCompl.tick();
	stComplCount++;
	stCcLevel--;
}

void TopProcess::report(ostream &os) const {
	os
		<< theSubm.count()
		<< "\t " << theSubm
		<< "\t " << theCompl.count()
		<< "\t " << theCompl
		<< "\t " << theErr.count()
		<< "\t " << (theSubm.count() - theCompl.count());
}
