#ifndef _ADDRESS_H_
#define _ADDRESS_H_ "$Id: Address.h,v 1.3.2.1 1998/09/22 07:43:53 rousskov Exp $"

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "Gadgets.h"

class Address {
	public:
		Address(): theHost(0), thePort(-1) {}
		Address(const char *aHost, int aPort): theHost(0), thePort(-1) { host(aHost); port(aPort); }
		Address(const Address &addr): theHost(0), thePort(-1) { *this = addr; }
		~Address() { delete[] theHost; }

		Address &operator = (const Address &addr) { host(addr.host()); port(addr.port()); return *this; }

		bool operator == (const Address &addr) const { return thePort == addr.thePort && strcasecmp(theHost, addr.theHost) == 0; }
		bool operator != (const Address &addr) const { return thePort != addr.thePort || strcasecmp(theHost, addr.theHost) != 0; }

		const char *host() const { return theHost; }
		int port() const { return thePort; }

		void host(const char *aHost) { delete[] theHost; theHost = StrDup(aHost); }
		void port(int aPort) { thePort = aPort; }

		ostream &print(ostream &os) const { return os << (theHost ? theHost : "?") << ':' << thePort; }

	protected:
		char *theHost;
		int thePort;
};

inline ostream &operator <<(ostream &os, const Address &addr) { return addr.print(os); }

#endif
