#ifndef _CONST_ADDR_RND_REQ_MAKER_H_
#define _CONST_ADDR_RND_REQ_MAKER_H_ "$Id: ConstAddrRndReqMaker.h,v 1.5.2.1 1998/09/22 07:44:03 rousskov Exp $"

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "ReqMaker.h"
#include "Address.h"

// creates request to a given host with a random url path
// tunnels request through a given proxy

class ConstAddrRndReqMaker: public ReqMaker {
	public:
		ConstAddrRndReqMaker(const Address &anAddr): theAddr(anAddr) {}
		virtual Thread *clone() const { return new ConstAddrRndReqMaker(theAddr); }

	public:
		virtual Size workOffset() const { return theConn->theWriterBuf.inOffset(); }
		virtual IOBuffer &workBuf() const { return theConn->theWriterBuf; }

		void genObjId(); // generates object id and stores it in ReqHdr
		virtual void doContent();

	protected:
		Address theAddr;
};

#endif
