// $Id: Rate.h,v 1.4.2.1 1998/09/22 07:44:18 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef _RATE_CLASS_H_
#define _RATE_CLASS_H_

#include "AppDef.h"

#include "Time.h"

// "count per time"
class Rate {
	public:
		Rate(): theCount(-1) {}
		Rate(int aCount, const Time &anInterval): theInterval(anInterval), theCount(aCount) {}
		
		inline ostream &print(ostream &os) const;
		bool valid() const { return theCount > 0 && theInterval > 0; }

	protected:
		Time theInterval;
		int theCount;
};

inline
ostream &Rate::print(ostream &os) const {
	if (valid())
		os << (double)theCount/theInterval.secd();
	else
		os << (double)-1;
	return os;
}

inline
ostream &operator <<(ostream &os, const Rate &r) { return r.print(os); }


#endif
