// $Id: RateMeter.h,v 1.1.2.1 1998/09/22 07:44:18 rousskov Exp $ 

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef _RATE_METER_H_
#define _RATE_METER_H_

#include "AppDef.h"
#include "Rate.h"

// handy to measure rates
class RateMeter {
	public:
		RateMeter(): theCount(0) {}

		int count() const { return theCount; }
		operator Rate() const { return Rate(theCount, theLastTime-theFirstTime); }

		RateMeter &operator +=(const RateMeter &);

		void tick();
		void reset() { theCount = 0; }

	protected:
		Time theFirstTime;  /* timestamp of the first tick */
		Time theLastTime;   /* timestamp of the last  tick */
		int theCount;		/* tick count */
};

#endif
