#ifndef _XACT_IO_THREAD_H_
#define _XACT_IO_THREAD_H_ "$Id: XactIOThread.h,v 1.5.2.1 1998/09/22 07:44:34 rousskov Exp $"

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "XactThread.h"
#include "SelectLoop.h"

// some xaction threads do IO
class XactIOThread: public XactThread, public IOer {
	public:
		XactIOThread(IODir ioDir): theReserv(-1, ioDir) {}
		virtual ~XactIOThread();

		// no ``rpc'' handlers

		virtual void checkProgress(); // checks if IO is ready
		virtual void init();
		virtual void run();

	protected:
		virtual void doIO() = 0;

	protected:
		SelectReserv theReserv; /* reserved slot in the select loop */
};

#endif
